require core.fs
require eval.fs

\
\ reading, parsing
\
require gray.fs
require graylist.fs

get-current
vocabulary scm-parser also scm-parser definitions

( grammar originally based on mini.fs from gray distribution )

( scanner )
( it is implemented using gray to give an example )
( that's probably not the best way )
256 constant eof-char
eof-char max-member ( the whole character set )

variable scm-file

variable tokenval 0 tokenval !
: token ( -- ) ( use: token name ) ( name: -- n )
 ( defines a token that returns a unique value )
 tokenval @ constant
 1 tokenval +! ;

token ";"
token ","
token "#"
token "("
token ")"
token Ident
token Number-token
token eof-token

table constant keyword-wordlist
    
variable numval
variable identp
variable identlen

: ident-string ( -- addr u )
 identp @ identlen @ ;

: adds ( addr1 c -- addr1+1 )
 ( accumulates char to string )
 over c! 1+ ;

variable ch

: testchar? ( set -- f )
 ch @ member? ;
' testchar? test-vector !

create c1 1 chars allot
create identloc 128 chars allot

: ?nextchar ( f -- )
 \ this will not earn a speed record
 ?not? abort" non-scheme character"
 c1 1 scm-file @ read-file abort" read-file error"
 if \ read <>0 chars
  c1 c@ ch !
 else
  eof-char ch !
 endif ;

: .. ( c1 c2 -- set )
 ( creates a set that includes the characters c, c1<=c<=c2 )
 empty copy-set
 swap 1+ rot do
  i over add-member
 loop ;

: x ( set1 -- set2 )
 ( read a char from the input and include it in the set )
    char singleton union ;

: ` ( -- terminal ) ( use: ` c )
 ( creates anonymous terminal for the character c )
 char singleton ['] ?nextchar make-terminal ;

: colon
    char : singleton ;

empty x ! x $ x % x & x * x / x < x = x > x ? x ^ x _ x ~ ' ?nextchar terminal special-initial
empty x + x - x . x @ ' ?nextchar terminal special-subsequent
char a char z ..  char A char Z ..  union  ' ?nextchar terminal letter
char 0 char 9 ..  ' ?nextchar  terminal digit
0 32 ..  ' ?nextchar  terminal blank
eof-char singleton ' ?nextchar terminal eof-scanner

(( blank **
   (( ` ;      {{ ";"  }}
   || ` ,      {{ ","  }}
   || ` #      {{ "#"  }}
   || ` (      {{ "("  }}
   || ` )      {{ ")"  }}
   || eof-scanner {{ eof-token }}
   || {{ 0 }}
      (( {{ 10 * ch @ + [char] 0 - }} cr digit )) ++
      {{ numval !  Number-token }}
   || {{ identloc identp ! identloc ch @ adds }} (( letter || special-initial ))
      (( {{ ch @ adds }} (( letter || special-initial || digit || special-subsequent )) )) **
     {{ identloc - identlen ! Ident }}
   || {{ identloc identp ! identloc ch @ adds }} (( ` + || ` - )) {{ drop 1 identlen ! Ident }}
   ))
)) <- symbol ( -- token )

symbol parser scan


( parser )
tokenval @ 1- max-member

variable sym

: testsym? ( set -- f )
 sym @ member? ;
' testsym? test-vector !

: ?nextsym ( f -- )
 ?not? abort" syntax error"
 scan sym ! ;

: t ( n -- ) ( use: token t name )
 singleton ['] ?nextsym terminal ;

get-order keyword-wordlist swap 1+ set-order
";" t ";"
"," t ","
"#" t "#"
"(" t "("
")" t ")"
Ident t Ident
Number-token t number-parser
eof-token t eof-parser
previous

nonterminal List-Elem
nonterminal P-Expr

(( {{ numval @ scm-make-inum }} number-parser )) <- Number

(( {{ ident-string scm-make-symbol }} ident )) <- Ident

(( Number 
|| Ident 
|| {{ scm-eol scm-bool-f scm-cons dup }}
    "(" List-Elem ** ")" {{ drop scm-cdr@ }}
)) <- Expr ( -- w )

(( Expr {{ scm-eol swap scm-cons tuck swap scm-cdr! }}
)) List-Elem rule ( wtail -- wtail ) 

(( {{ drop dup }} Expr {{ scm-eval }} )) P-Expr rule ( wenv w -- wresult )

(( Expr || {{ scm-eof }} )) <- R-Expr

R-Expr parser scm-parse-expr

\ API
set-current

: scm-set-input-file ( w-file -- )
    scm-file ! true ?nextchar true ?nextsym ;

: scm-read ( -- wresult )
    \ read an expression from current input port
    scm-parse-expr ;

: scm-load ( wenv -- wresult ) { wenv }
    scm-eof begin
	scm-read dup scm-eof <> while
	    ( w-prev-result wexpr ) nip wenv swap scm-eval
    repeat drop ;

previous




\ arch-tag: 9eebcce9-71bd-4ca5-ba2d-59e6f82d6fb4
\ (do not remove this comment)
