require eval.fs

: scm-%bind-variable ( wenv wsym-lst wval -- wenv wsym-lst )
    rot dup >r -rot ( r: wenv )
    swap scm-pair@ rot scm-make-variable swap r> scm-environment-define! ;

: scm-%closure-invoke ( wcode wenv wformals wargs -- wresult )
    2dup scm-list-length swap scm-list-length <>
    s" invalid number of arguments to closure" exception and throw
    rot scm-make-environment -rot ( wcode wnew-env wformals wargs  )
    ['] scm-%bind-variable scm-for-each drop ( wcode wnew-env )
    swap scm-eval ;

: scm-make-closure ( wenv wcode wformals -- wproc )
    2>r :noname
    ( wenv wargs; r: wcode wformals ) 2r>
    ]] literal literal [[ ( wenv wargs wformals wcode )
    ]] swap 2swap swap -rot [[
    ( wcode wenv wformals wargs ) ]] scm-%closure-invoke ; [[
    ( wenv xt ) scm-make-procedure ;

: scm-check-formals ( wformals addr uchars -- )
    rot scm-pair? 0= -rot exception and throw ;

: scm.~lambda ( wenv wforms -- wproc )
    dup scm-list-length 1 < s" missing expression in lambda form" exception and throw
    scm-pair@ dup s" invalid lambda formals" scm-check-formals
    swap s" begin" scm-make-symbol scm-cons swap
    ( wenv wcode wformals ) scm-make-closure ;

: scm.~define ( wenv wforms -- wresult )
    dup scm-list-length 2 <> s" invalid define form" exception and throw
    scm-pair@ swap scm-pair@ nip swap ( wenv wval wsym  ) 
    dup scm-symbol? 0= s" cannot define non-symbol" exception and throw
    >r over swap scm-eval ( wenv wval ) scm-make-variable
    swap r> swap scm-environment-define!
    scm-unspecified ;

: scm.~set! ( wenv wforms -- wresult )
    dup scm-list-length 2 <> s" invalid set! form" exception and throw
    scm-pair@ dup scm-symbol? 0= s" invalid set! form" exception and throw
    swap scm-car@ >r over scm-environment-lookup ( wenv wvar )
    dup scm-bool-f = s" unbound variable" exception and throw
    swap r> scm-eval swap scm-variable!
    scm-unspecified ;

: scm.~if ( wenv wforms -- wresult ) { wenv wforms }
    wforms scm-list-length 3 <>
    s" missing or extra if expression" exception and throw
    wenv wforms scm-car@ scm-eval scm-bool-f = if
	wenv wforms scm-cdr@ scm-cdr@ scm-car@ scm-eval
    else
	wenv wforms scm-cdr@ scm-car@ scm-eval
    endif ;

: scm-%nip-eval ( wenv wprev wform -- wenv wresult )
    nip over swap scm-eval ;

: scm.~begin ( wenv wforms -- wresult )
    scm-eol swap ['] scm-%nip-eval scm-for-each nip ;




\ arch-tag: 06b632e7-f16b-492a-88b7-065f547157b0
\ (do not remove this comment)
